Code

Make merge-recursive honor diff.renamelimit
[git.git] / git-pull.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # Fetch one or more remote refs and merge it/them into the current HEAD.
7 USAGE='[-n | --no-summary] [--no-commit] [-s strategy]... [<fetch-options>] <repo> <head>...'
8 LONG_USAGE='Fetch one or more remote refs and merge it/them into the current HEAD.'
9 SUBDIRECTORY_OK=Yes
10 . git-sh-setup
11 set_reflog_action "pull $*"
12 require_work_tree
13 cd_to_toplevel
15 test -z "$(git ls-files -u)" ||
16         die "You are in the middle of a conflicted merge."
18 strategy_args= no_summary= no_commit= squash=
19 while :
20 do
21         case "$1" in
22         -n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
23                 --no-summa|--no-summar|--no-summary)
24                 no_summary=-n ;;
25         --summary)
26                 no_summary=$1
27                 ;;
28         --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
29                 no_commit=--no-commit ;;
30         --sq|--squ|--squa|--squas|--squash)
31                 squash=--squash ;;
32         -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
33                 --strateg=*|--strategy=*|\
34         -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
35                 case "$#,$1" in
36                 *,*=*)
37                         strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
38                 1,*)
39                         usage ;;
40                 *)
41                         strategy="$2"
42                         shift ;;
43                 esac
44                 strategy_args="${strategy_args}-s $strategy "
45                 ;;
46         -h|--h|--he|--hel|--help)
47                 usage
48                 ;;
49         *)
50                 # Pass thru anything that may be meant for fetch.
51                 break
52                 ;;
53         esac
54         shift
55 done
57 orig_head=$(git rev-parse --verify HEAD 2>/dev/null)
58 git-fetch --update-head-ok "$@" || exit 1
60 curr_head=$(git rev-parse --verify HEAD 2>/dev/null)
61 if test "$curr_head" != "$orig_head"
62 then
63         # The fetch involved updating the current branch.
65         # The working tree and the index file is still based on the
66         # $orig_head commit, but we are merging into $curr_head.
67         # First update the working tree to match $curr_head.
69         echo >&2 "Warning: fetch updated the current branch head."
70         echo >&2 "Warning: fast forwarding your working tree from"
71         echo >&2 "Warning: commit $orig_head."
72         git update-index --refresh 2>/dev/null
73         git read-tree -u -m "$orig_head" "$curr_head" ||
74                 die 'Cannot fast-forward your working tree.
75 After making sure that you saved anything precious from
76 $ git diff '$orig_head'
77 output, run
78 $ git reset --hard
79 to recover.'
81 fi
83 merge_head=$(sed -e '/  not-for-merge   /d' \
84         -e 's/  .*//' "$GIT_DIR"/FETCH_HEAD | \
85         tr '\012' ' ')
87 case "$merge_head" in
88 '')
89         curr_branch=$(git symbolic-ref -q HEAD)
90         case $? in
91           0) ;;
92           1) echo >&2 "You are not currently on a branch; you must explicitly"
93              echo >&2 "specify which branch you wish to merge:"
94              echo >&2 "  git pull <remote> <branch>"
95              exit 1;;
96           *) exit $?;;
97         esac
98         curr_branch=${curr_branch#refs/heads/}
100         echo >&2 "You asked me to pull without telling me which branch you"
101         echo >&2 "want to merge with, and 'branch.${curr_branch}.merge' in"
102         echo >&2 "your configuration file does not tell me either.  Please"
103         echo >&2 "name which branch you want to merge on the command line and"
104         echo >&2 "try again (e.g. 'git pull <repository> <refspec>')."
105         echo >&2 "See git-pull(1) for details on the refspec."
106         echo >&2
107         echo >&2 "If you often merge with the same branch, you may want to"
108         echo >&2 "configure the following variables in your configuration"
109         echo >&2 "file:"
110         echo >&2
111         echo >&2 "    branch.${curr_branch}.remote = <nickname>"
112         echo >&2 "    branch.${curr_branch}.merge = <remote-ref>"
113         echo >&2 "    remote.<nickname>.url = <url>"
114         echo >&2 "    remote.<nickname>.fetch = <refspec>"
115         echo >&2
116         echo >&2 "See git-config(1) for details."
117         exit 1
118         ;;
119 ?*' '?*)
120         if test -z "$orig_head"
121         then
122                 echo >&2 "Cannot merge multiple branches into empty head"
123                 exit 1
124         fi
125         ;;
126 esac
128 if test -z "$orig_head"
129 then
130         git update-ref -m "initial pull" HEAD $merge_head "" &&
131         git read-tree --reset -u HEAD || exit 1
132         exit
133 fi
135 merge_name=$(git fmt-merge-msg <"$GIT_DIR/FETCH_HEAD") || exit
136 exec git-merge $no_summary $no_commit $squash $strategy_args \
137         "$merge_name" HEAD $merge_head